package main

import (
	"bufio"
	"bytes"
	"testing"
)

func TestExample1(t *testing.T) {
	inputStr := `0123
1234
8765
9876`

	expected :=
		[]int{0, 1, 2, 3, 1, 2, 3, 4, 8, 7, 6, 5, 9, 8, 7, 6}

	buf := bytes.NewBuffer([]byte(inputStr))

	topMap := make([]int, 0, len(inputStr))
	trailheads := make([]int, 0, 1)

	r := bufio.NewReader(buf)

	w, topMap, trailheads, err :=
		readMap(topMap, trailheads, r)
	if err != nil {
		t.Errorf("%v", err)
	}

	if w != 4 {
		t.Errorf("unexpected width %d", w)
	}
	if len(trailheads) != 1 || trailheads[0] != 0 {
		t.Errorf("erroneous trailheads")
	}

	for i := range topMap {
		if topMap[i] != expected[i] {
			col := (i % w) + 1
			line := (i / w) + 1
			t.Errorf("At line %d, column %d: expected %d; got %d", line, col, expected[i], topMap[i])
		}
	}
}
