package main

import (
	"testing"
)

func TestMachines(t *testing.T) {
	machines := []struct {
		an, bn      int
		a, b, prize Coord
	}{
		{an: 80, bn: 40,
			a: Coord{94, 34}, b: Coord{22, 67},
			prize: Coord{8400, 5400},
		},
		{an: -1, bn: -1,
			a: Coord{26, 66}, b: Coord{67, 21},
			prize: Coord{12748, 12176},
		},
		{an: 38, bn: 86,
			a: Coord{17, 86}, b: Coord{84, 37},
			prize: Coord{7870, 6450},
		},
		{an: -1, bn: -1,
			a: Coord{69, 23}, b: Coord{27, 71},
			prize: Coord{18641, 10279},
		},
	}
	for _, m := range machines {
		an, bn := solve(m.a, m.b, m.prize)
		if an != m.an || bn != m.bn {
			t.Errorf("machine %v: got an=%d, bn=%d", m, an, bn)
		}
	}
}
